(function() {
    if (window.DfaceJSBridge) {
        _log('DfaceJSBridge has loaded');
        return;
    }

    JsInterface.callHandler = function(funName, param, callback) {
       if (param instanceof Object) {
            param = JSON.stringify(param);
       }
       JsInterface.call(funName, param, callback);
    };

    JsInterface.call = function(funName, param, callback) {
        _log('DfaceJSBridge.call -' + ' funName:' + funName + ' param:' + param + ' callback:' + callback);
        if (callback != null) {
            return eval(callback)(JsInterface.callInternal(funName, param));
        }
        return JsInterface.callInternal(funName, param);
    };

    function _log(msg) {
        JsInterface.logJsDebugInfo(msg);
    }

    getDfaceSharedObject = function() {
        if (typeof(DfaceSharedObject) != 'undefined') {
            return JSON.stringify(DfaceSharedObject);
        }

        var getSharedImages = function() {
            if (typeof(DfaceSharedObject) != 'undefined') {
                return DfaceSharedObject.image;
            }

            var defaultimg = "http://static.dface.cn/img/share.png";
            var allImgs = document.getElementsByTagName("img");

            if (allImgs.length != 0) {
                for (var i = 0; i < allImgs.length; i++) {
                    var img = allImgs[i];
                    if (img.style.display == 'none' || img.style.visibility == 'hidden') {
                        continue;
                    }

                    if (img.width >= 100 || img.height >= 100) {
                        return img.src;
                    }
                }
            }

            return defaultimg;
        };

        var getSharedTitle = function() {
            if (typeof(DfaceSharedObject) != 'undefined') {
                return DfaceSharedObject.title;
            }

            var title = document.title;
            if (title == "") {
                title = '';
            }

            return title;
        };

        var getSharedDescription = function() {
            if (typeof(DfaceSharedObject) != 'undefined') {
                return DfaceSharedObject.descprition;
            }

            var title = document.title;
            if (title == "") {
                title = '';
            }

            return title;
        };

        var getSharedUrl = function() {
            if (typeof(DfaceSharedObject) != 'undefined') {
                return DfaceSharedObject.url;
            }

            return location.href;
        };

        var dfaceShareObject = {
            thumb: getSharedImages(),
            title: getSharedTitle(),
            desc: getSharedDescription(),
            url: getSharedUrl()
        };

        return JSON.stringify(dfaceShareObject);
    };

    getWxSharedObject = function() {
        if (typeof(wxSharedObject) != 'undefined') {
            return JSON.stringify(wxSharedObject);
        }

        var getSharedImages = function() {
            if (typeof(wxSharedObject) != 'undefined') {
                return wxSharedObject.image;
            }

            var defaultimg = "http://static.dface.cn/img/share.png";
            var allImgs = document.getElementsByTagName("img");

            if (allImgs.length != 0) {
                for (var i = 0; i < allImgs.length; i++) {
                    var img = allImgs[i];
                    if (img.style.display == 'none' || img.style.visibility == 'hidden') {
                        continue;
                    }

                    if (img.width >= 100 || img.height >= 100) {
                        return img.src;
                    }
                }
            }

            return defaultimg;
        };

        var getSharedTitle = function() {
            if (typeof(wxSharedObject) != 'undefined') {
                return wxSharedObject.title;
            }

            var title = document.title;
            if (title == "") {
                title = '';
            }

            return title;
        };

        var getSharedDescription = function() {
            if (typeof(wxSharedObject) != 'undefined') {
                return wxSharedObject.descprition;
            }

            var title = document.title;
            if (title == "") {
                title = '';
            }

            return title;
        };

        var getSharedUrl = function() {
            if (typeof(wxSharedObject) != 'undefined') {
                return wxSharedObject.url;
            }

            return location.href;
        };

        var WxSharedObject = {
            thumb: getSharedImages(),
            title: getSharedTitle(),
            desc: getSharedDescription(),
            url: getSharedUrl()
        };

        return JSON.stringify(WxSharedObject);
    };

    window.DfaceJSBridge = JsInterface;

    var readyEvent = document.createEvent('Events');
    readyEvent.initEvent('DfaceJSBridgeReady');
    document.dispatchEvent(readyEvent);
    _log('DfaceJSBridge is ready');
})();